import java.util.List;

import algorithm.CalculateShortestPath;
import data.Graph;
import data.ManhattanGeometry1;
import data.ManhattanGeometry2;
import data.Node;


public class Main {
	public static void main(String[] args) {
		doDijkstra(new ManhattanGeometry1(), false);
		doDijkstra(new ManhattanGeometry2(), true);
	}
	static void doDijkstra(Graph geom, boolean verbose) {		
		CalculateShortestPath dijkstra = new CalculateShortestPath(geom.rootNode(), geom.getDestination(), geom, geom);
		Node pathHandle = dijkstra.execute();
		dijkstra.print(pathHandle, verbose);
		// alternative way of using the result: request a forward-sorted list of nodes:
		printForward(dijkstra.getPath());
		System.out.println("Distance is "+dijkstra.getDistanceFromOrigin(pathHandle));
	}
	static void printForward(List<Node> path) {
		for (Node node : path)
			System.out.print("Node "+node.getName()+" ");
		System.out.println();
	}
}
