package data;


public abstract class Graph {

	protected Node[] nodes;
	protected Node root;
	protected Node destination;
	
	
	public int getNumNodes() { return nodes.length; }
	public Node getNodeAt(int i) { return nodes[i]; }
	
	public Node rootNode() { return this.root; }
	public Node getDestination() { return this.destination; }
	
	public abstract Node eastNeighborOf(Node node);
	public abstract Node southNeighborOf(Node node);
	
	public abstract int getDistance(Node from, Node to);
}
