package data;

import java.util.HashMap;
import java.util.Map;

import common.Numbers;

public class ManhattanGeometry extends Graph {

	// note: this is a sparse map, nested maps may potentially be null
	Map<Node,Map<Node,Integer>> distances = new HashMap<Node,Map<Node,Integer>>();
	
	Map<Node,Node> nextDownTheStreetFrom = new HashMap<Node,Node>();
	Map<Node,Node> nextDownTheAvenueFrom = new HashMap<Node,Node>();

	protected void connectSouth(Node from, Node to, int dist) {
		Map<Node,Integer> nodeMap = this.distances.get(from);
		if (nodeMap == null) 
			this.distances.put(from, nodeMap = new HashMap<Node, Integer>());
		nodeMap.put(to, dist);
		this.nextDownTheAvenueFrom.put(from, to);
	}
	protected void connectEast(Node from, Node to, int dist) {
		Map<Node,Integer> nodeMap = this.distances.get(from);
		if (nodeMap == null) 
			this.distances.put(from, nodeMap = new HashMap<Node, Integer>());
		nodeMap.put(to, dist);
		this.nextDownTheStreetFrom.put(from, to);
	}
	@Override
	public Node eastNeighborOf(Node node) {
		return this.nextDownTheStreetFrom.get(node);
	}

	@Override
	public Node southNeighborOf(Node node) {
		return this.nextDownTheAvenueFrom.get(node);
	}
	
	@Override
	public int getDistance(Node from, Node to) {
		Map<Node,Integer> nodeMap = this.distances.get(from);
		if (nodeMap == null) return Numbers.INFINITY;
		Integer value = nodeMap.get(to);
		if (value == null) return Numbers.INFINITY;
		return value;
	}
}
