package data;


public class ManhattanGeometry1 extends ManhattanGeometry {

	public ManhattanGeometry1() {
		String[]names = {"a", "b", "c", "d", "e", "f", "g", "h", "i"};
		this.nodes = new Node[names.length];
		for (int i=0;i<names.length;i++) 
				nodes[i] = new Node(names[i]); 
		/*
         # Grid is of Manhattan form: 
         # 
         #   a - 2 - b - 3 - c 
         #   |       |       | 
         #   1       2       1 
         #   |       |       | 
         #   d - 1 - e - 1 - f 
         #   |               | 
         #   2               4 
         #   |               | 
         #   g - 1 - h - 2 - i 
         # 
		 */
		Node a = nodes[0], b = nodes[1], c = nodes[2],
			 d = nodes[3], e = nodes[4], f = nodes[5],
			 g = nodes[6], h = nodes[7], i = nodes[8];
		this.root = a;
		this.destination = i;
		connectEast(a, b, 2);
		connectEast(b, c, 3);
		connectSouth(a, d, 1);
		connectSouth(b, e, 2);
		connectSouth(c, f, 1);
		connectEast(d, e, 1);
		connectEast(e, f, 1);
		connectSouth(d, g, 2);
		connectSouth(f, i, 4);
		connectEast(g, h, 1);
		connectEast(h, i, 2);
	}
}
