package data;

public class ManhattanGeometry2 extends ManhattanGeometry {

	public ManhattanGeometry2() {
		String[]names = {"a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k"};
		this.nodes = new Node[names.length];
		for (int i=0;i<nodes.length;i++) 
				nodes[i] = new Node(names[i]); 
		/*
         # Grid is of Manhattan form: 
         # 
         #   a - 2 - b - 3 - c - 1 - j 
         #   |       |       |       | 
         #   1       2       1       | 
         #   |       |       |       | 
         #   d - 1 - e - 1 - f       1 
         #   |       |               | 
         #   2       4               | 
         #   |       |               | 
         #   g - 1 - h - 2 - i - 2 - k 
		 */
		int n = 0;
		Node a = nodes[n++], b = nodes[n++], c = nodes[n++], d = nodes[n++], e = nodes[n++], f = nodes[n++],
			 g = nodes[n++], h = nodes[n++], i = nodes[n++], j = nodes[n++], k = nodes[n++];
		this.root = a;
		this.destination = k;
		connectEast(a, b, 2);
		connectEast(b, c, 3);
		connectEast(c, j, 1);
		
		connectSouth(a, d, 1);
		connectSouth(b, e, 2);
		connectSouth(c, f, 1);
		connectSouth(j, k, 1);
		
		connectEast(d, e, 1);
		connectEast(e, f, 1);
		
		connectSouth(d, g, 2);
		connectSouth(e, h, 4);
		
		connectEast(g, h, 1);
		connectEast(h, i, 2);
		connectEast(i, k, 2);
	}
}
